/* $Id: xlock.c,v 1.2 2007/09/02 23:44:55 mgdepalma Exp $
 *
 * Copyright (C) 2007 Softcraft Impresa, LLC <info@softcraft.org>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; You may only use version 2 of the License,
 * you have no option to use any other version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "module.h"
#include "gpanel.h"

/*
 * (private) action
 */
static void
action (GtkWidget *widget, gpointer data)
{
  system ("xlock");
} /* </action> */

/*
 * Required methods
 */
void
module_init (Modulus *self, GlobalPanel *panel)
{
  self->name    = "xlock";
  self->release = "0.2";
  self->place   = PACK_START;
  self->space   = MODULI_SPACE_TASKBAR;
} /* </module_init> */

/*
 * Optional methods
 */
void
module_open (Modulus *self, GlobalPanel *panel)
{
  GtkWidget *button;
  GtkWidget *label = NULL;
  PanelIcons *icons = panel->icons;

  /* construct the user interface */
  button = gtk_button_new();
  gtk_button_set_relief (GTK_BUTTON(button), GTK_RELIEF_NONE);
  g_signal_connect (G_OBJECT (button), "clicked", G_CALLBACK (action), panel);

  if (self->icon) {
    const gchar *file = file_path_find (icons->path, self->icon);

    if (file != NULL) {
      label = image_new_from_file_scaled (file, icons->size, icons->size);
      panel_update_pack_position (panel, self->place, NULL, icons->size);
    }
  }

  if (label == NULL) {
    label = gtk_label_new(self->name);
    panel_update_pack_position (panel, self->place, label, 0);
  }

  gtk_container_add (GTK_CONTAINER(button), label);
  gtk_widget_show (label);

  self->widget = button;
} /* module_open */

void
module_close (Modulus *self, GlobalPanel *panel)
{
  gtk_widget_destroy (self->widget);
} /* module_close */
